'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _storybook = require('@kadira/storybook');

var _Checkbox = require('../components/forms/Checkbox');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _storybook.storiesOf)('Checkbox', module).add('general', function () {
    return _react2.default.createElement(General, null);
}).add('sizes', function () {
    return _react2.default.createElement(Sizes, null);
}).add('callbacks', function () {
    return _react2.default.createElement(Callbacks, null);
}); /**
     * Created by cmeyers on 11/14/16.
     */


var style = { padding: 10 };

function General() {
    return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
            'div',
            { style: style },
            _react2.default.createElement(_Checkbox.Checkbox, { label: 'Unchecked' })
        ),
        _react2.default.createElement(
            'div',
            { style: style },
            _react2.default.createElement(_Checkbox.Checkbox, { checked: true, label: 'Checked' })
        ),
        _react2.default.createElement(
            'div',
            { style: style },
            _react2.default.createElement(_Checkbox.Checkbox, { disabled: true, label: 'Disabled' })
        ),
        _react2.default.createElement(
            'div',
            { style: style },
            _react2.default.createElement(_Checkbox.Checkbox, { checked: true, disabled: true, label: 'Disabled, Checked' })
        ),
        _react2.default.createElement(
            'div',
            { style: style },
            _react2.default.createElement(_Checkbox.Checkbox, { className: 'focus', label: 'Focused' })
        ),
        _react2.default.createElement(
            'div',
            { style: style },
            _react2.default.createElement(_Checkbox.Checkbox, { checked: true, className: 'focus', label: 'Focused, Checked' })
        )
    );
}

function Sizes() {
    return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
            'div',
            { style: style },
            _react2.default.createElement(_Checkbox.Checkbox, { label: 'Using no layout' })
        ),
        _react2.default.createElement(
            'div',
            { className: 'layout-small', style: style },
            _react2.default.createElement(_Checkbox.Checkbox, { label: 'Using layout-small' })
        ),
        _react2.default.createElement(
            'div',
            { className: 'layout-medium', style: style },
            _react2.default.createElement(_Checkbox.Checkbox, { label: 'Using layout-medium' })
        ),
        _react2.default.createElement(
            'div',
            { className: 'layout-large', style: style },
            _react2.default.createElement(_Checkbox.Checkbox, { label: 'Using layout-large' })
        )
    );
}

function Callbacks() {
    return _react2.default.createElement(
        'div',
        { style: style },
        _react2.default.createElement(_Checkbox.Checkbox, {
            label: 'Toggle Me',
            onToggle: function onToggle(val) {
                return console.log('onToggle', val);
            }
        })
    );
}
//# sourceMappingURL=CheckboxStories.js.map
